#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "lparx.h"
ifelse(NDIM,2,@
#include "cadez_hierarchy2.h"
#include "cadez_residuals2.h"
#include "cadez_dsolvs2.h"
@,NDIM,3,@
#include "cadez_hierarchy3.h"
#include "cadez_residuals3.h"
#include "cadez_dsolvs3.h"
@)

ifelse(NDIM,2,@
#define I_X 0
#define I_Y 1
@,NDIM,3,@
#define I_W 0
#define I_X 1
#define I_Y 2
@)

ifelse(NDIM,2,@
#define N_SMOOTHS 5
@,NDIM,3,@
#define N_SMOOTHS 10
@)

void printX(XArray1(GridX(double)) &);

ifelse(NDIM,2,@
F_ID ID_SmoothR3(cadez_discretization &, int);
@,NDIM,3,@
F_ID ID_SmoothR3(cadez_discretization &, int, const Point3 &, const Point3 &);
@)

F_ID ID_ResidualR3(cadez_discretization &, int);

ifelse(NDIM,2,@
extern "FORTRAN" void ftoc4x4(double *, double *, int *, int *, int *, int*);
@,NDIM,3,@
extern "FORTRAN" void ftoc4x4x4(double *, double *, int *, int *, int *, int*);
@)

extern "FORTRAN" void resid_trans(double *, double *, int *, int *, int*);

ifelse(NDIM,2,@
extern "FORTRAN" void ctof3x3(double *, double *, int *, int *, int *, int *);
@,NDIM,3,@
extern "FORTRAN" void ctof3x3x3(double *, double *, int *, int *, int *, int *);
@)

extern GridReductionFunctionID Make_Tau_id;
extern GridReductionFunctionID CG_Correct_id;

void cadez_hierarchy::mg3(const int lev, F_ID & Resnorms,
									F_ID & Taunorms, const int pr)
{
	if(lev == 1-BS_nlevels) {	// solve coarse grid
		cadez_discretization & c3 = *BS_level[-lev];
		Resnorms = ID_ResidualR3(c3,1);
		for_all_1(i,c3.PsiD)
			RegionX R3_test = c3.interiors[i]*c3.domain_R3;
			if(!R3_test.empty()) {
ifelse(NDIM,2,@
				int KD = c3.domain_R3.extents(0);
				psi_ds(c3.PsiD(i).data(), c3.Psi(i).data(),
							c3.KK(i).data(), c3.PsiRes(i).data(),
							c3.LapX(i).data(), c3.LapY(i).data(),
							c3.Volume(i).data(),
							Mat_R3,Upd_R3, (int *)(c3.extents+i),
							(int *)(c3.interiors+i),KD);
@,NDIM,3,@
				int KD = c3.domain_R3.extents(0)*
							c3.domain_R3.extents(1);
				psi_ds(c3.PsiD(i).data(), c3.Psi(i).data(),
							c3.KK(i).data(), c3.PsiRes(i).data(),
							c3.LapW(i).data(), c3.LapX(i).data(),
							c3.LapY(i).data(), c3.Volume(i).data(),
							Mat_R3,Upd_R3, (int *)(c3.extents+i),
							(int *)(c3.interiors+i),KD);
@)
			}
		end_for_all
	} else {	// take multigrid step
		cadez_discretization & f = *BS_level[-lev];
		cadez_discretization & c = *BS_level[1-lev];
ifelse(NDIM,3,@
		const int N = c.domain_R3.extents(I_W);
		Point3 up(0); up(I_W) = N;
		Point3 dn(0); dn(I_W) = -N;
		const Point3 upf = up*2;
		const Point3 dnf = dn*2;
@)
//
//	Pre-smoothing
ifelse(NDIM,2,@
		Resnorms = ID_SmoothR3(f,N_SMOOTHS);
@,NDIM,3,@
		Resnorms = ID_SmoothR3(f,N_SMOOTHS,upf,dnf);
@)
		if(pr > 2 && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << "MG3 " << setw(2) << lev << " U| "
										<< setw(10) << Resnorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
//
//	Move PsiD to coarse grid
		for_all_1(l,f.PsiC)
			if(!f.coarse_interiors[l].empty()) {
ifelse(NDIM,2,@
				ftoc4x4(f.PsiD(l).data(),f.PsiC(l).data(),
					(int *)(f.extents+l),(int *)(f.fills+l),
					(int *)(f.coarse_interiors+l),(int *)(f.coarse_extents+l));
//
//	Set the inner boundary.
				if(f.coarse_interiors[l].lower(I_Y) == 1) {
					int i;
					int il = f.coarse_interiors[l].lower(I_X);
					int ih = f.coarse_interiors[l].upper(I_X);
					if(f.coarse_fills[l].lower(I_X) == il) {
						i = il;
						f.PsiC(l)(i,0) =
							0.68359375*(f.PsiD(l)(2*i-1,0) - f.PsiD(l)(2*i-1,1) -
					 		            f.PsiD(l)(2*i+1,0) + f.PsiD(l)(2*i+1,1)  ) +
							0.41015625*(f.PsiD(l)(2*i-1,2) - f.PsiD(l)(2*i+1,2)  ) -
							0.09765625*(f.PsiD(l)(2*i-1,3) - f.PsiD(l)(2*i+1,3)  ) +
							2.05078125*(f.PsiD(l)(2*i  ,0) - f.PsiD(l)(2*i  ,1)  ) +
							1.23046875* f.PsiD(l)(2*i  ,2)                         -
							0.29296875* f.PsiD(l)(2*i  ,3)                         +
							0.13671875*(f.PsiD(l)(2*i+2,0) - f.PsiD(l)(2*i+2,1)  ) +
							0.08203125* f.PsiD(l)(2*i+2,2)                         -
							0.01953125* f.PsiD(l)(2*i+2,3);
						il = il + 1;
					}
@) ifelse(NDIM,2,@
					if(f.coarse_fills[l].upper(I_X) == ih) {
						i = ih;
						f.PsiC(l)(i,0) =
							0.68359375*(f.PsiD(l)(2*i  ,0) - f.PsiD(l)(2*i  ,1) -
					 		            f.PsiD(l)(2*i-2,0) + f.PsiD(l)(2*i-2,1)  ) +
							0.41015625*(f.PsiD(l)(2*i  ,2) - f.PsiD(l)(2*i-2,2)  ) -
							0.09765625*(f.PsiD(l)(2*i  ,3) - f.PsiD(l)(2*i-2,3)  ) +
							2.05078125*(f.PsiD(l)(2*i-1,0) - f.PsiD(l)(2*i-1,1)  ) +
							1.23046875* f.PsiD(l)(2*i-1,2)                         -
							0.29296875* f.PsiD(l)(2*i-1,3)                         +
							0.13671875*(f.PsiD(l)(2*i-3,0) - f.PsiD(l)(2*i-3,1)  ) +
							0.08203125* f.PsiD(l)(2*i-3,2)                         -
							0.01953125* f.PsiD(l)(2*i-3,3);
						ih = ih - 1;
					}
					for(i=il; i <= ih; ++i) {
						f.PsiC(l)(i,0) =
							1.23046875*(f.PsiD(l)(2*i  ,0) + f.PsiD(l)(2*i-1,0) -
							            f.PsiD(l)(2*i  ,1) - f.PsiD(l)(2*i-1,1)  ) +
							0.73828125*(f.PsiD(l)(2*i  ,2) + f.PsiD(l)(2*i-1,2))   -
							0.17578125*(f.PsiD(l)(2*i  ,3) + f.PsiD(l)(2*i-1,3))   -
							0.13671875*(f.PsiD(l)(2*i+1,0) + f.PsiD(l)(2*i-2,0) -
							            f.PsiD(l)(2*i+1,1) - f.PsiD(l)(2*i-2,1)  ) -
							0.08203125*(f.PsiD(l)(2*i+1,2) + f.PsiD(l)(2*i-2,2))   +
							0.01953125*(f.PsiD(l)(2*i+1,3) + f.PsiD(l)(2*i-2,3));
					}
				}
@) ifelse(NDIM,3,@
				ftoc4x4x4(f.PsiD(l).data(),f.PsiC(l).data(),
					(int *)(f.extents+l),(int *)(f.fills+l),
					(int *)(f.coarse_interiors+l),(int *)(f.coarse_extents+l));
//
//	Set the inner boundary.
				if(f.coarse_interiors[l].lower(I_Y) == 1) {
					int i,j;
					int jl = f.coarse_interiors[l].lower(I_W);
					int jh = f.coarse_interiors[l].upper(I_W);
					int il = f.coarse_interiors[l].lower(I_X);
					int ih = f.coarse_interiors[l].upper(I_X);
					if(f.coarse_fills[l].lower(I_X) == il) {
						i = il;
						for(j=jl; j <= jh; ++j) {
							f.PsiC(l)(j,i,0) =
								0.000244140625*(
									+ 4725.0*(f.PsiD(l)(2*j-1,2*i  ,0) - f.PsiD(l)(2*j-1,2*i  ,1) +
												 f.PsiD(l)(2*j  ,2*i  ,0) - f.PsiD(l)(2*j  ,2*i  ,1)  ) 
									+ 2835.0*(f.PsiD(l)(2*j-1,2*i  ,2) + f.PsiD(l)(2*j  ,2*i  ,2)  ) 
									+ 1575.0*(f.PsiD(l)(2*j-1,2*i-1,0) - f.PsiD(l)(2*j-1,2*i-1,1) -
												 f.PsiD(l)(2*j-1,2*i+1,0) + f.PsiD(l)(2*j-1,2*i+1,1) +
												 f.PsiD(l)(2*j  ,2*i-1,0) - f.PsiD(l)(2*j  ,2*i-1,1) -
												 f.PsiD(l)(2*j  ,2*i+1,0) + f.PsiD(l)(2*j  ,2*i+1,1)  ) 
									+  945.0*(f.PsiD(l)(2*j-1,2*i-1,2) - f.PsiD(l)(2*j-1,2*i+1,2) +
												 f.PsiD(l)(2*j  ,2*i-1,2) - f.PsiD(l)(2*j  ,2*i+1,2)  ) 
									-  675.0*(f.PsiD(l)(2*j-1,2*i  ,3) + f.PsiD(l)(2*j  ,2*i  ,3)  ) 
									-  525.0*(f.PsiD(l)(2*j-2,2*i  ,0) - f.PsiD(l)(2*j-2,2*i  ,1) +
												 f.PsiD(l)(2*j+1,2*i  ,0) - f.PsiD(l)(2*j+1,2*i  ,1)  ) 
									-  315.0*(f.PsiD(l)(2*j-2,2*i  ,2) - f.PsiD(l)(2*j-1,2*i+2,0) +
												 f.PsiD(l)(2*j-1,2*i+2,1) - f.PsiD(l)(2*j  ,2*i+2,0) +
												 f.PsiD(l)(2*j  ,2*i+2,1) + f.PsiD(l)(2*j+1,2*i  ,2)  ) 
									-  225.0*(f.PsiD(l)(2*j-1,2*i-1,3) - f.PsiD(l)(2*j-1,2*i+1,3) +
												 f.PsiD(l)(2*j  ,2*i-1,3) - f.PsiD(l)(2*j  ,2*i+1,3)  ) 
									+  189.0*(f.PsiD(l)(2*j-1,2*i+2,2) + f.PsiD(l)(2*j  ,2*i+2,2)  ) 
									-  175.0*(f.PsiD(l)(2*j-2,2*i-1,0) - f.PsiD(l)(2*j-2,2*i-1,1) -
												 f.PsiD(l)(2*j-2,2*i+1,0) + f.PsiD(l)(2*j-2,2*i+1,1) +
												 f.PsiD(l)(2*j+1,2*i-1,0) - f.PsiD(l)(2*j+1,2*i-1,1) -
												 f.PsiD(l)(2*j+1,2*i+1,0) + f.PsiD(l)(2*j+1,2*i+1,1)  )
									-  105.0*(f.PsiD(l)(2*j-2,2*i-1,2) - f.PsiD(l)(2*j-2,2*i+1,2) +
												 f.PsiD(l)(2*j+1,2*i-1,2) - f.PsiD(l)(2*j+1,2*i+1,2)  ) 
									+   75.0*(f.PsiD(l)(2*j-2,2*i  ,3) + f.PsiD(l)(2*j+1,2*i  ,3)  ) 
									-   45.0*(f.PsiD(l)(2*j-1,2*i+2,3) + f.PsiD(l)(2*j  ,2*i+2,3)  ) 
									-   35.0*(f.PsiD(l)(2*j-2,2*i+2,0) - f.PsiD(l)(2*j-2,2*i+2,1) +
												 f.PsiD(l)(2*j+1,2*i+2,0) - f.PsiD(l)(2*j+1,2*i+2,1)  ) 
									+   25.0*(f.PsiD(l)(2*j-2,2*i-1,3) - f.PsiD(l)(2*j-2,2*i+1,3) +
												 f.PsiD(l)(2*j+1,2*i-1,3) - f.PsiD(l)(2*j+1,2*i+1,3)  ) 
									-   21.0*(f.PsiD(l)(2*j-2,2*i+2,2) + f.PsiD(l)(2*j+1,2*i+2,2)  ) 
									+    5.0*(f.PsiD(l)(2*j-2,2*i+2,3) + f.PsiD(l)(2*j+1,2*i+2,3)  )
								);
						}
						il = il + 1;
					}
@) ifelse(NDIM,3,@
					if(f.coarse_fills[l].upper(I_X) == ih) {
						i = ih;
						for(j=jl; j <= jh; ++j) {
							f.PsiC(l)(j,i,0) =
								0.000244140625*(
									+ 4725.0*(f.PsiD(l)(2*j-1,2*i-1,0) - f.PsiD(l)(2*j-1,2*i-1,1) +
												 f.PsiD(l)(2*j  ,2*i-1,0) - f.PsiD(l)(2*j  ,2*i-1,1)  ) 
									+ 2835.0*(f.PsiD(l)(2*j-1,2*i-1,2) + f.PsiD(l)(2*j  ,2*i-1,2)  ) 
									+ 1575.0*(f.PsiD(l)(2*j-1,2*i  ,0) - f.PsiD(l)(2*j-1,2*i  ,1) -
												 f.PsiD(l)(2*j-1,2*i-2,0) + f.PsiD(l)(2*j-1,2*i-2,1) +
												 f.PsiD(l)(2*j  ,2*i  ,0) - f.PsiD(l)(2*j  ,2*i  ,1) -
												 f.PsiD(l)(2*j  ,2*i-2,0) + f.PsiD(l)(2*j  ,2*i-2,1)  ) 
									+  945.0*(f.PsiD(l)(2*j-1,2*i  ,2) - f.PsiD(l)(2*j-1,2*i-2,2) +
												 f.PsiD(l)(2*j  ,2*i  ,2) - f.PsiD(l)(2*j  ,2*i-2,2)  ) 
									-  675.0*(f.PsiD(l)(2*j-1,2*i-1,3) + f.PsiD(l)(2*j  ,2*i-1,3)  ) 
									-  525.0*(f.PsiD(l)(2*j-2,2*i-1,0) - f.PsiD(l)(2*j-2,2*i-1,1) +
												 f.PsiD(l)(2*j+1,2*i-1,0) - f.PsiD(l)(2*j+1,2*i-1,1)  ) 
									-  315.0*(f.PsiD(l)(2*j-2,2*i-1,2) - f.PsiD(l)(2*j-1,2*i-3,0) +
												 f.PsiD(l)(2*j-1,2*i-3,1) - f.PsiD(l)(2*j  ,2*i-3,0) +
												 f.PsiD(l)(2*j  ,2*i-3,1) + f.PsiD(l)(2*j+1,2*i-1,2)  ) 
									-  225.0*(f.PsiD(l)(2*j-1,2*i  ,3) - f.PsiD(l)(2*j-1,2*i-2,3) +
												 f.PsiD(l)(2*j  ,2*i  ,3) - f.PsiD(l)(2*j  ,2*i-2,3)  ) 
									+  189.0*(f.PsiD(l)(2*j-1,2*i-3,2) + f.PsiD(l)(2*j  ,2*i-3,2)  ) 
									-  175.0*(f.PsiD(l)(2*j-2,2*i  ,0) - f.PsiD(l)(2*j-2,2*i  ,1) -
												 f.PsiD(l)(2*j-2,2*i-2,0) + f.PsiD(l)(2*j-2,2*i-2,1) +
												 f.PsiD(l)(2*j+1,2*i  ,0) - f.PsiD(l)(2*j+1,2*i  ,1) -
												 f.PsiD(l)(2*j+1,2*i-2,0) + f.PsiD(l)(2*j+1,2*i-2,1)  )
									-  105.0*(f.PsiD(l)(2*j-2,2*i  ,2) - f.PsiD(l)(2*j-2,2*i-2,2) +
												 f.PsiD(l)(2*j+1,2*i  ,2) - f.PsiD(l)(2*j+1,2*i-2,2)  ) 
									+   75.0*(f.PsiD(l)(2*j-2,2*i-1,3) + f.PsiD(l)(2*j+1,2*i-1,3)  ) 
									-   45.0*(f.PsiD(l)(2*j-1,2*i-3,3) + f.PsiD(l)(2*j  ,2*i-3,3)  ) 
									-   35.0*(f.PsiD(l)(2*j-2,2*i-3,0) - f.PsiD(l)(2*j-2,2*i-3,1) +
												 f.PsiD(l)(2*j+1,2*i-3,0) - f.PsiD(l)(2*j+1,2*i-3,1)  ) 
									+   25.0*(f.PsiD(l)(2*j-2,2*i  ,3) - f.PsiD(l)(2*j-2,2*i-2,3) +
												 f.PsiD(l)(2*j+1,2*i  ,3) - f.PsiD(l)(2*j+1,2*i-2,3)  ) 
									-   21.0*(f.PsiD(l)(2*j-2,2*i-3,2) + f.PsiD(l)(2*j+1,2*i-3,2)  ) 
									+    5.0*(f.PsiD(l)(2*j-2,2*i-3,3) + f.PsiD(l)(2*j+1,2*i-3,3)  )
								);
						}
						ih = ih - 1;
					}
@) ifelse(NDIM,3,@
					for(i=il; i <= ih; ++i) {
						for(j=jl; j <= jh; ++j) {
							f.PsiC(l)(j,i,0) =
								0.000244140625*(
									2835.0*(f.PsiD(l)(2*j-1,2*i  ,0) + f.PsiD(l)(2*j-1,2*i-1,0) 
											+ f.PsiD(l)(2*j  ,2*i  ,0) + f.PsiD(l)(2*j  ,2*i-1,0) 
											- f.PsiD(l)(2*j-1,2*i  ,1) - f.PsiD(l)(2*j-1,2*i-1,1) 
											- f.PsiD(l)(2*j  ,2*i  ,1) - f.PsiD(l)(2*j  ,2*i-1,1)  ) 
								+	1701.0*(f.PsiD(l)(2*j-1,2*i  ,2) + f.PsiD(l)(2*j-1,2*i-1,2)   
											+ f.PsiD(l)(2*j  ,2*i  ,2) + f.PsiD(l)(2*j  ,2*i-1,2)  ) 
								-	 405.0*(f.PsiD(l)(2*j-1,2*i  ,3) + f.PsiD(l)(2*j-1,2*i-1,3)    
											+ f.PsiD(l)(2*j  ,2*i  ,3) + f.PsiD(l)(2*j  ,2*i-1,3)  ) 
								-	 315.0*(f.PsiD(l)(2*j-2,2*i-1,0) + f.PsiD(l)(2*j-2,2*i  ,0)
											+ f.PsiD(l)(2*j-1,2*i-2,0) + f.PsiD(l)(2*j-1,2*i+1,0)
											+ f.PsiD(l)(2*j  ,2*i-2,0) + f.PsiD(l)(2*j  ,2*i+1,0)
											+ f.PsiD(l)(2*j+1,2*i-1,0) + f.PsiD(l)(2*j+1,2*i  ,0)
											- f.PsiD(l)(2*j-2,2*i-1,1) - f.PsiD(l)(2*j-2,2*i  ,1)
											- f.PsiD(l)(2*j-1,2*i-2,1) - f.PsiD(l)(2*j-1,2*i+1,1)
											- f.PsiD(l)(2*j  ,2*i-2,1) - f.PsiD(l)(2*j  ,2*i+1,1)
											- f.PsiD(l)(2*j+1,2*i-1,1) - f.PsiD(l)(2*j+1,2*i  ,1)  ) 
								-	 189.0*(f.PsiD(l)(2*j-1,2*i+1,2) + f.PsiD(l)(2*j-1,2*i-2,2)    
											+ f.PsiD(l)(2*j  ,2*i+1,2) + f.PsiD(l)(2*j  ,2*i-2,2) 
											+ f.PsiD(l)(2*j-2,2*i  ,2) + f.PsiD(l)(2*j-2,2*i-1,2)    
											+ f.PsiD(l)(2*j+1,2*i  ,2) + f.PsiD(l)(2*j+1,2*i-1,2)  ) 
								+	  45.0*(f.PsiD(l)(2*j-1,2*i+1,3) + f.PsiD(l)(2*j-1,2*i-2,3) 
											+ f.PsiD(l)(2*j  ,2*i+1,3) + f.PsiD(l)(2*j  ,2*i-2,3) 
											+ f.PsiD(l)(2*j-2,2*i  ,3) + f.PsiD(l)(2*j-2,2*i-1,3)    
											+ f.PsiD(l)(2*j+1,2*i  ,3) + f.PsiD(l)(2*j+1,2*i-1,3)  ) 
								+	  35.0*(f.PsiD(l)(2*j-2,2*i+1,0) + f.PsiD(l)(2*j-2,2*i-2,0) 
											+ f.PsiD(l)(2*j+1,2*i+1,0) + f.PsiD(l)(2*j+1,2*i-2,0) 
											- f.PsiD(l)(2*j-2,2*i+1,1) - f.PsiD(l)(2*j-2,2*i-2,1) 
											- f.PsiD(l)(2*j+1,2*i+1,1) - f.PsiD(l)(2*j+1,2*i-2,1)  ) 
								+	  21.0*(f.PsiD(l)(2*j-2,2*i+1,2) + f.PsiD(l)(2*j-2,2*i-2,2)    
											+ f.PsiD(l)(2*j+1,2*i+1,2) + f.PsiD(l)(2*j+1,2*i-2,2)  ) 
								-	   5.0*(f.PsiD(l)(2*j-2,2*i+1,3) + f.PsiD(l)(2*j-2,2*i-2,3) 
											+ f.PsiD(l)(2*j+1,2*i+1,3) + f.PsiD(l)(2*j+1,2*i-2,3)  )
								);
						}
					}
				}
@)
//
			}
			for_1(m,f.PsiC)
				if(m != l) f.PsiC(m).copy(f.PsiC(l),
											f.coarse_fills[m]*f.coarse_interiors[l]);
ifelse(NDIM,3,@
				Region3 R = f.coarse_fills[m]*shift(f.coarse_interiors[l],up);
//				f.PsiC(m).copy(f.PsiC(l),shift(R,dn),R);
				f.PsiC(m).copy(f.PsiC(l),R,shift(R,dn));
				R = f.coarse_fills[m]*shift(f.coarse_interiors[l],dn);
//				f.PsiC(m).copy(f.PsiC(l),shift(R,up),R);
				f.PsiC(m).copy(f.PsiC(l),R,shift(R,up));
@)
			end_for
		end_for_all
		for_all_1(l,c.PsiD)
			for_1(m,f.PsiC)
				RegionX ibnd = f.coarse_interiors[m];
				if(ibnd.lower(I_Y) == 1) ibnd.lower(I_Y) = 0;	// copy inner boundary
				c.PsiD(l).copy(f.PsiC(m),c.fills[l]*ibnd);
ifelse(NDIM,3,@
				Region3 R = c.fills[l]*shift(f.coarse_interiors[m],up);
//				c.PsiD(l).copy(f.PsiC(m),shift(R,dn),R);
				c.PsiD(l).copy(f.PsiC(m),R,shift(R,dn));
				R = c.fills[l]*shift(f.coarse_interiors[m],dn);
//				c.PsiD(l).copy(f.PsiC(m),shift(R,up),R);
				c.PsiD(l).copy(f.PsiC(m),R,shift(R,up));
@)
      	end_for
		end_for_all
		c.sync_fields();
//
//	Compute residual on coarse grid without Tau, store into Tau.
		int no_tau = 0;
		for_all_1(l,c.PsiD)
ifelse(NDIM,2,@
			psiresid(Resnorms.Psi,
						c.Psi(l).data(),c.PsiD(l).data(),c.KK(l).data(),
						c.PsiTau(l).data(),c.PsiTau(l).data(),
						c.LapX(l).data(),c.LapY(l).data(),c.Volume(l).data(),
						(int *)(c.extents+l), (int *)(c.interiors+l),
						(int *)(c.fills+l),no_tau);
			const Grid2(double) & src = c.Refine_Mask(l);
			Grid2(double) & dst = c.PsiTau(l);
			BeginFastIndex2(src, const double);
			BeginFastIndex2(dst, double);
			for_2(i,j,c.interiors[l])
				if(FastIndex2(src,i,j) != 0.0) FastIndex2(dst,i,j) = 0.0;
			end_for
			EndFastIndex2(src);
			EndFastIndex2(dst);
@,NDIM,3,@
			psiresid(Resnorms.Psi,
						c.Psi(l).data(),c.PsiD(l).data(),c.KK(l).data(),
						c.PsiTau(l).data(),c.PsiTau(l).data(),
						c.LapW(l).data(),c.LapX(l).data(),c.LapY(l).data(),
						c.Volume(l).data(),(int *)(c.extents+l),
						(int *)(c.interiors+l),(int *)(c.fills+l),no_tau);
			const Grid3(double) & src = c.Refine_Mask(l);
			Grid3(double) & dst = c.PsiTau(l);
			BeginFastIndex3(src, const double);
			BeginFastIndex3(dst, double);
			for_3(i,j,k,c.interiors[l])
				if(FastIndex3(src,i,j,k) != 0.0) FastIndex3(dst,i,j,k) = 0.0;
			end_for
			EndFastIndex3(src);
			EndFastIndex3(dst);
@)
      end_for_all
//
//	Move fine residual to coarse grid and compute coarse Tau
		for_all_1(l,f.PsiRes)
			if(!f.coarse_interiors[l].empty()) 
				resid_trans(f.PsiRes(l).data(),f.PsiCT(l).data(),
							(int *)(f.extents+l),(int *)(f.coarse_interiors+l),
							(int *)(f.coarse_extents+l));
			for_1(m,c.PsiTau)
				c.PsiTau(m).copy(f.PsiCT(l),c.interiors[m]*f.coarse_interiors[l],
										Make_Tau_id);
			end_for
		end_for_all
//
//	Compute L2 norm of Tau
		double Tau;
		F_ID tnorms;
		for_all_1(l,c.PsiTau)
			const GridX(double) & src = c.PsiTau(l);
			BeginFastIndexNDIM(src, const double);
ifelse(NDIM,2,@
			for_2(i,j,c.interiors[l])
				Tau = FastIndex2(src,i,j);
				tnorms.Psi += Tau*Tau;
//				tnorms.Psi += abs(Tau);
			end_for
@,NDIM,3,@
			for_3(i,j,k,c.interiors[l])
				Tau = FastIndex3(src,i,j,k);
				tnorms.Psi += Tau*Tau;
//				tnorms.Psi += abs(Tau);
			end_for
@)
			EndFastIndexNDIM(src);
      end_for_all_no_sync
		mpReduceAdd(&tnorms.Psi);
		tnorms.Psi = sqrt(tnorms.Psi);
		Taunorms = tnorms;
		if(pr > 2 && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << "MG3 " << setw(2) << lev << " T| "
										<< setw(10) << Taunorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
//
//	Solve coarseer level
		mg3(lev-1, Resnorms, tnorms, pr);
//
//	Compute coarse grid correction
		for_all_1(l,f.PsiC)
			for_1(m,c.PsiD)
				f.PsiC(l).copy(c.PsiD(m),c.interiors[m]*f.coarse_fills[l],
									CG_Correct_id);
ifelse(NDIM,3,@
				Region3 R = shift(c.interiors[m],up)*f.coarse_fills[l];
//				f.PsiC(l).copy(c.PsiD(m),shift(R,dn),R,CG_Correct_id);
				f.PsiC(l).copy(c.PsiD(m),R,shift(R,dn),CG_Correct_id);
				R = shift(c.interiors[m],dn)*f.coarse_fills[l];
//				f.PsiC(l).copy(c.PsiD(m),shift(R,up),R,CG_Correct_id);
				f.PsiC(l).copy(c.PsiD(m),R,shift(R,up),CG_Correct_id);
@)
			end_for
		end_for_all
		for_all_1(l,f.PsiD)
			if(!f.coarse_interiors[l].empty()) {
				RegionX fcf = f.coarse_fills[l];
				if(f.coarse_interiors[l].lower(I_Y) == 1) fcf.lower(I_Y) = 1;
ifelse(NDIM,2,@
				ctof3x3(f.PsiRes(l).data(),f.PsiC(l).data(),
					(int *)(f.extents+l),(int *)(f.coarse_interiors+l),
					(int *)(f.coarse_extents+l),(int *)(&fcf));
				const Grid2(double) & src2 = f.PsiRes(l);
				Grid2(double) & dst2 = f.PsiD(l);
				BeginFastIndex2(src2, const double);
				BeginFastIndex2(dst2, double);
				for_2(i,j,f.fills[l])
					FastIndex2(dst2,i,j) += FastIndex2(src2,i,j);
				end_for
				EndFastIndex2(src2);
				EndFastIndex2(dst2);
@,NDIM,3,@
				ctof3x3x3(f.PsiRes(l).data(),f.PsiC(l).data(),
					(int *)(f.extents+l),(int *)(f.coarse_interiors+l),
					(int *)(f.coarse_extents+l),(int *)(&fcf));
				const Grid3(double) & src2 = f.PsiRes(l);
				Grid3(double) & dst2 = f.PsiD(l);
				BeginFastIndex3(src2, const double);
				BeginFastIndex3(dst2, double);
				for_3(i,j,k,f.fills[l])
					FastIndex3(dst2,i,j,k) += FastIndex3(src2,i,j,k);
				end_for
				EndFastIndex3(src2);
				EndFastIndex3(dst2);
@)
			}
      end_for_all
		for_all_1(l,f.PsiD)
			for_1(m,f.PsiD)
				if(l != m) f.PsiD(m).copy(f.PsiD(l),f.fills[m]*
																f.interiors[l]*f.domain_R3);
ifelse(NDIM,3,@
				Region3 R = f.fills[m]*shift(f.interiors[l]*f.domain_R3,upf);
//				f.PsiD(m).copy(f.PsiD(l),shift(R,dnf),R);
				f.PsiD(m).copy(f.PsiD(l),R,shift(R,dnf));
				R = f.fills[m]*shift(f.interiors[l]*f.domain_R3,dnf);
//				f.PsiD(m).copy(f.PsiD(l),shift(R,upf),R);
				f.PsiD(m).copy(f.PsiD(l),R,shift(R,upf));
@)
			end_for
		end_for_all
		f.sync_fields();
//
//
ifelse(NDIM,2,@
		Resnorms = ID_SmoothR3(f,N_SMOOTHS);
@,NDIM,3,@
		Resnorms = ID_SmoothR3(f,N_SMOOTHS,upf,dnf);
@)
		if(pr > 2 && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << "MG3 " << setw(2) << lev << " D| "
										<< setw(10) << Resnorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
	}
}

ifelse(NDIM,2,@
#include "cadez_smoothers2.h"
@,NDIM,3,@
#include "cadez_smoothers3.h"
@)

ifelse(NDIM,2,@
F_ID ID_SmoothR3(cadez_discretization & lev,int N_smooths)
@,NDIM,3,@
F_ID ID_SmoothR3(cadez_discretization & lev,int N_smooths,
							const Point3 & up, const Point3 & dn)
@)
{
	const int red = 0, black = 1;
	for(int loop = 0; loop < N_smooths; ++loop) {
		for_all_1(l,lev.PsiD)
			RegionX r3tst = lev.domain_R3 * lev.interiors[l];
			if(!r3tst.empty()) {
ifelse(NDIM,2,@
				psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
								lev.KK(l).data(),lev.PsiTau(l).data(),
								lev.LapX(l).data(),lev.LapY(l).data(),
								lev.Volume(l).data(),(int *)(lev.extents+l),
								(int *)(lev.interiors+l),(int *)(lev.fills+l),red);
				psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
								lev.KK(l).data(),lev.PsiTau(l).data(),
								lev.LapX(l).data(),lev.LapY(l).data(),
								lev.Volume(l).data(),(int *)(lev.extents+l),
								(int *)(lev.interiors+l),(int *)(lev.fills+l),black);
@,NDIM,3,@
				psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
								lev.KK(l).data(),lev.PsiTau(l).data(),
								lev.LapW(l).data(),lev.LapX(l).data(),
								lev.LapY(l).data(),lev.Volume(l).data(),
								(int *)(lev.extents+l),(int *)(lev.interiors+l),
								(int *)(lev.fills+l),red);
				psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
								lev.KK(l).data(),lev.PsiTau(l).data(),
								lev.LapW(l).data(),lev.LapX(l).data(),
								lev.LapY(l).data(),lev.Volume(l).data(),
								(int *)(lev.extents+l),(int *)(lev.interiors+l),
								(int *)(lev.fills+l),black);
@)
			}
		end_for_all
		for_all_1(l,lev.PsiD)
			for_1(m,lev.PsiD)
				if(l != m) lev.PsiD(m).copy(lev.PsiD(l),lev.fills[m]*
														(lev.interiors[l]*lev.domain_R3));
ifelse(NDIM,3,@
				Region3 R = lev.fills[m]*shift(lev.interiors[l]*lev.domain_R3,up);
//				lev.PsiD(m).copy(lev.PsiD(l),shift(R,dn),R);
				lev.PsiD(m).copy(lev.PsiD(l),R,shift(R,dn));
				R = lev.fills[m]*shift(lev.interiors[l]*lev.domain_R3,dn);
//				lev.PsiD(m).copy(lev.PsiD(l),shift(R,up),R);
				lev.PsiD(m).copy(lev.PsiD(l),R,shift(R,up));
@)
			end_for
		end_for_all
		for_all_1(l,lev.PsiD)
			RegionX r3tst = lev.domain_R3 * lev.interiors[l];
			if(!r3tst.empty()) {
				const GridX(double) & src = lev.PsiD(l);
				GridX(double) & dst = lev.Psi(l);
				BeginFastIndexNDIM(src, const double);
				BeginFastIndexNDIM(dst, double);
ifelse(NDIM,2,@
				for_2(i,j,lev.fills[l])
					FastIndex2(dst,i,j) = 1.0 + FastIndex2(src,i,j);
				end_for
@,NDIM,3,@
				for_3(i,j,k,lev.fills[l])
					FastIndex3(dst,i,j,k) = 1.0 + FastIndex3(src,i,j,k);
				end_for
@)
				EndFastIndexNDIM(src);
				EndFastIndexNDIM(dst);
			}	
		end_for_all
	}
	return ID_ResidualR3(lev,1);
} // ID_SmoothR3

F_ID ID_ResidualR3(cadez_discretization & lev,int UseTau)
{
	F_ID Resids;
	for_all_1(l,lev.PsiD)
		RegionX r3tst = lev.domain_R3 * lev.interiors[l];
		if(!r3tst.empty()) {
ifelse(NDIM,2,@
			psiresid(Resids.Psi,
						lev.Psi(l).data(),lev.PsiD(l).data(),
						lev.KK(l).data(),lev.PsiTau(l).data(),
						lev.PsiRes(l).data(),lev.LapX(l).data(),
						lev.LapY(l).data(),lev.Volume(l).data(),
						(int *)(lev.extents+l),(int *)(lev.interiors+l),
						(int *)(lev.fills+l),UseTau);
@,NDIM,3,@
			psiresid(Resids.Psi,
						lev.Psi(l).data(),lev.PsiD(l).data(),
						lev.KK(l).data(),lev.PsiTau(l).data(),
						lev.PsiRes(l).data(),lev.LapW(l).data(),
						lev.LapX(l).data(),lev.LapY(l).data(),lev.Volume(l).data(),
						(int *)(lev.extents+l),(int *)(lev.interiors+l),
						(int *)(lev.fills+l),UseTau);
@)
		}
	end_for_all_no_sync
	mpReduceAdd(&Resids.Psi);
	Resids.Psi = sqrt(Resids.Psi);
	return Resids;
} // ID_ResidualR3
