#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "lparx.h"
ifelse(NDIM,2,@
#include "cadez_hierarchy2.h"
#include "cadez_residuals2.h"
@,NDIM,3,@
#include "cadez_hierarchy3.h"
#include "cadez_residuals3.h"
@)

ifelse(NDIM,2,@
#define I_X 0
#define I_Y 1
@,NDIM,3,@
#define I_W 0
#define I_X 1
#define I_Y 2
@)

#define NDUPFIELDS 1

ifelse(NDIM,2,@
#define N_SMOOTHS 5
@,NDIM,3,@
#define N_SMOOTHS 20
@)

void printX(XArray1(GridX(double)) &);

F_ID ID_Smooth(cadez_discretization &, int);

ifelse(NDIM,2,@
extern "FORTRAN" void ftoc4x4(double *, double *, int *, int *, int *, int*);
@,NDIM,3,@
extern "FORTRAN" void ftoc4x4x4(double *, double *, int *, int *, int *, int*);
@)

extern "FORTRAN" void resid_trans(double *, double *, int *, int *, int*);

ifelse(NDIM,2,@
extern "FORTRAN" void ctof3x3(double *, double *, int *, int *, int *, int *);
@,NDIM,3,@
extern "FORTRAN" void ctof3x3x3(double *, double *, int *, int *, int *, int *);
@)

void Make_Tau(GridX(double)& dst, const RegionX& to,
					const GridX(double)& src, const RegionX& from)
{
BeginFastIndexNDIM(src, const double);
BeginFastIndexNDIM(dst, double);
ifelse(NDIM,2,@
	for_2(i,j,to)
		FastIndex2(dst,i,j) -= FastIndex2(src,i,j);
	end_for
@,NDIM,3,@
	for_3(i,j,k,to)
		FastIndex3(dst,i,j,k) -= FastIndex3(src,i,j,k);
	end_for
@)
EndFastIndexNDIM(src);
EndFastIndexNDIM(dst);
}

void CG_Correct(GridX(double)& dst, const RegionX& to,
					const GridX(double)& src, const RegionX& from)
{
BeginFastIndexNDIM(src, const double);
BeginFastIndexNDIM(dst, double);
ifelse(NDIM,2,@
	for_2(i,j,to)
		FastIndex2(dst,i,j) = FastIndex2(src,i,j) - FastIndex2(dst,i,j);
	end_for
@,NDIM,3,@
	const int di = from.lower(0) - to.lower(0);
	for_3(i,j,k,to)
		FastIndex3(dst,i,j,k) = FastIndex3(src,i+di,j,k) - FastIndex3(dst,i,j,k);
	end_for
@)
EndFastIndexNDIM(src);
EndFastIndexNDIM(dst);
}
extern GridReductionFunctionID Make_Tau_id;
extern GridReductionFunctionID CG_Correct_id;

void cadez_hierarchy::mg_init_data(const int lev,
												F_ID & Resnorms, F_ID & Taunorms,
												const int pr)
{
static TimeSection timer2("mg_init_data()");
timer2.enter_section();
	if(lev == 0) {	// solve coarse grid
		Resnorms = coarse_solve_ID(Taunorms*0.01,pr);
      if(Taunorms == 0.0) Taunorms = Resnorms*0.01;
	} else {	// take multigrid step
		cadez_discretization & f = *level[lev];
		cadez_discretization & c = *level[lev-1];
ifelse(NDIM,3,@
		const int N = c.domain_R3.extents(I_W);
		Point3 up(0); up(I_W) = N;
		Point3 dn(0); dn(I_W) = -N;
		const Point3 upf = up*2;
		const Point3 dnf = dn*2;
@)
//
//	Pre-smoothing
		Resnorms = ID_Smooth(f,N_SMOOTHS);
		if(pr && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << setw(2) << lev << " U| "
										<< setw(10) << Resnorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
//
//	Move PsiD to coarse grid
		for_all_1(l,f.PsiC)
ifelse(NDIM,2,@
			ftoc4x4(f.PsiD(l).data(),f.PsiC(l).data(),
				(int *)(f.extents+l),(int *)(f.fills+l),
				(int *)(f.coarse_interiors+l),(int *)(f.coarse_extents+l));
@,NDIM,3,@
			ftoc4x4x4(f.PsiD(l).data(),f.PsiC(l).data(),
				(int *)(f.extents+l),(int *)(f.fills+l),
				(int *)(f.coarse_interiors+l),(int *)(f.coarse_extents+l));
@)
			for_1(m,c.PsiD)
				c.PsiD(m).copy(f.PsiC(l),c.fills[m]*f.coarse_interiors[l]);
ifelse(NDIM,3,@
				Region3 R = c.fills[m]*shift(f.coarse_interiors[l],up);
//				c.PsiD(m).copy(f.PsiC(l),shift(R,dn),R);
				c.PsiD(m).copy(f.PsiC(l),R,shift(R,dn));
				R = c.fills[m]*shift(f.coarse_interiors[l],dn);
//				c.PsiD(m).copy(f.PsiC(l),shift(R,up),R);
				c.PsiD(m).copy(f.PsiC(l),R,shift(R,up));
@)
			end_for
		end_for_all
		c.sync_fields();
//
//	Compute residual on coarse grid without Tau, store into Tau.
		int no_tau = 0;
//
		for_all_1(l,c.PsiD)
//	"Hide" this copy here.
//	Really only need to copy the f.PsiC fill zones without the interior.
//	Is there a better way to do this?
			for_1(m,f.PsiC)
				f.PsiC(m).copy(c.PsiD(l),c.fills[l]*f.coarse_fills[m]);
ifelse(NDIM,3,@
// Note: "Periodic-Phi" copy not needed here!
@)
			end_for
//
ifelse(NDIM,2,@
			psiresid(Resnorms.Psi,
						c.Psi(l).data(),c.PsiD(l).data(),c.KK(l).data(),
						c.PsiTau(l).data(),c.PsiTau(l).data(),
						c.LapX(l).data(),c.LapY(l).data(),c.Volume(l).data(),
						(int *)(c.extents+l),(int *)(c.interiors+l),
						(int *)(c.fills+l),no_tau);
			const Grid2(double) & src = c.Refine_Mask(l);
			Grid2(double) & dst = c.PsiTau(l);
			BeginFastIndex2(src, const double);
			BeginFastIndex2(dst, double);
			for_2(i,j,c.interiors[l])
				if(FastIndex2(src,i,j) != 0.0) FastIndex2(dst,i,j) = 0.0;
			end_for
			EndFastIndex2(src);
			EndFastIndex2(dst);
@,NDIM,3,@
			psiresid(Resnorms.Psi,
						c.Psi(l).data(),c.PsiD(l).data(),c.KK(l).data(),
						c.PsiTau(l).data(),c.PsiTau(l).data(),
						c.LapW(l).data(),c.LapX(l).data(),c.LapY(l).data(),
						c.Volume(l).data(),(int *)(c.extents+l),
						(int *)(c.interiors+l),(int *)(c.fills+l),no_tau);
			const Grid3(double) & src = c.Refine_Mask(l);
			Grid3(double) & dst = c.PsiTau(l);
			BeginFastIndex3(src, const double);
			BeginFastIndex3(dst, double);
			for_3(i,j,k,c.interiors[l])
				if(FastIndex3(src,i,j,k) != 0.0) FastIndex3(dst,i,j,k) = 0.0;
			end_for
			EndFastIndex3(src);
			EndFastIndex3(dst);
@)
		end_for_all
//
//	Move fine residual to coarse grid and compute coarse Tau
		for_all_1(l,f.PsiRes)
			resid_trans(f.PsiRes(l).data(),f.PsiCT(l).data(),
							(int *)(f.extents+l),(int *)(f.coarse_interiors+l),
							(int *)(f.coarse_extents+l));
			for_1(m,c.PsiTau)
				c.PsiTau(m).copy(f.PsiCT(l),c.interiors[m]*f.coarse_interiors[l],
										Make_Tau_id);
			end_for
		end_for_all
//
//	Compute L2 norm of Tau
		double Tau;
		F_ID tnorms;
		for_all_1(l,c.PsiTau)
			const GridX(double) & src = c.PsiTau(l);
			BeginFastIndexNDIM(src, const double);
ifelse(NDIM,2,@
			for_2(i,j,c.interiors[l])
				Tau = FastIndex2(src,i,j);
				tnorms.Psi += Tau*Tau;
//				tnorms.Psi += abs(Tau);
			end_for
@,NDIM,3,@
			for_3(i,j,k,c.interiors[l])
				Tau = FastIndex3(src,i,j,k);
				tnorms.Psi += Tau*Tau;
//				tnorms.Psi += abs(Tau);
			end_for
@)
			EndFastIndexNDIM(src);
		end_for_all_no_sync
		mpReduceAdd(&tnorms.Psi);
		tnorms.Psi = sqrt(tnorms.Psi);
		Taunorms = tnorms;
		if(pr && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << setw(2) << lev << " T| "
										<< setw(10) << Taunorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
//
//	Solve coarseer level
timer2.exit_section();
		mg_init_data(lev-1, Resnorms, tnorms, pr);
timer2.enter_section();
//
//	Compute coarse grid correction
		for_all_1(l,f.PsiC)
			for_1(m,c.PsiD)
				f.PsiCT(l).copy(c.PsiD(m),c.fills[m]*f.coarse_fills[l]);
ifelse(NDIM,3,@
				Region3 R = shift(c.fills[m],up)*f.coarse_fills[l];
//				f.PsiCT(l).copy(c.PsiD(m),shift(R,dn),R);
				f.PsiCT(l).copy(c.PsiD(m),R,shift(R,dn));
				R = shift(c.fills[m],dn)*f.coarse_fills[l];
//				f.PsiCT(l).copy(c.PsiD(m),shift(R,up),R);
				f.PsiCT(l).copy(c.PsiD(m),R,shift(R,up));
@)
			end_for
		end_for_all
		for_all_1(l,f.PsiD)
ifelse(NDIM,2,@
			const Grid2(double) & src = f.PsiCT(l);
			Grid2(double) & dst = f.PsiC(l);
			BeginFastIndex2(src, const double);
			BeginFastIndex2(dst, double);
			for_2(i,j,f.coarse_fills[l])
				FastIndex2(dst,i,j) = FastIndex2(src,i,j) -
														FastIndex2(dst,i,j);
			end_for
			EndFastIndex2(src);
			EndFastIndex2(dst);
			ctof3x3(f.PsiRes(l).data(),f.PsiC(l).data(),
				(int *)(f.extents+l),(int *)(f.coarse_prolong+l),
				(int *)(f.coarse_extents+l),(int *)(f.coarse_fills+l));
			const Grid2(double) & src2 = f.PsiRes(l);
			Grid2(double) & dst2 = f.PsiD(l);
			BeginFastIndex2(src2, const double);
			BeginFastIndex2(dst2, double);
			for_2(i,j,f.fills[l])
				FastIndex2(dst2,i,j) += FastIndex2(src2,i,j);
			end_for
			EndFastIndex2(src2);
			EndFastIndex2(dst2);
@,NDIM,3,@
			const Grid3(double) & src = f.PsiCT(l);
			Grid3(double) & dst = f.PsiC(l);
			BeginFastIndex3(src, const double);
			BeginFastIndex3(dst, double);
			for_3(i,j,k,f.coarse_fills[l])
				FastIndex3(dst,i,j,k) = FastIndex3(src,i,j,k) -
														FastIndex3(dst,i,j,k);
			end_for
			EndFastIndex3(src);
			EndFastIndex3(dst);
			ctof3x3x3(f.PsiRes(l).data(),f.PsiC(l).data(),
				(int *)(f.extents+l),(int *)(f.coarse_prolong+l),
				(int *)(f.coarse_extents+l),(int *)(f.coarse_fills+l));
			const Grid3(double) & src2 = f.PsiRes(l);
			Grid3(double) & dst2 = f.PsiD(l);
			BeginFastIndex3(src2, const double);
			BeginFastIndex3(dst2, double);
			for_3(i,j,k,f.fills[l])
				FastIndex3(dst2,i,j,k) += FastIndex3(src2,i,j,k);
			end_for
			EndFastIndex3(src2);
			EndFastIndex3(dst2);
@)
		end_for_all
		for_all_1(l,f.PsiD)
			for_1(m,f.PsiD)
				if(l != m) f.PsiD(m).copy(f.PsiD(l),f.fills[m]*f.interiors[l]);
ifelse(NDIM,3,@
				Region3 R = f.fills[m]*shift(f.interiors[l],upf);
//				f.PsiD(m).copy(f.PsiD(l),shift(R,dnf),R);
				f.PsiD(m).copy(f.PsiD(l),R,shift(R,dnf));
				R = f.fills[m]*shift(f.interiors[l],dnf);
//				f.PsiD(m).copy(f.PsiD(l),shift(R,upf),R);
				f.PsiD(m).copy(f.PsiD(l),R,shift(R,upf));
@)
			end_for
		end_for_all
	//
	//	Set duplicate fill points
		if(f.dup_cnt > 0) {
ifelse(NDIM,3,@
			const int N = f.domain_R3.extents(I_W);
@)
			for(int m = 0; m < NDUPFIELDS*f.dup_cnt; m++) f.dup_value[m] = 0.0;
			for_all_1(l,f.PsiD)
				const int l0 = f.fills[l].lower(0);
				const int l1 = f.fills[l].lower(1);
				ifelse(NDIM,3,const int l2 = f.fills[l].lower(2);)
				const int h0 = f.fills[l].upper(0);
				const int h1 = f.fills[l].upper(1);
				ifelse(NDIM,3,const int h2 = f.fills[l].upper(2);)
				for(int m = 0; m < f.dup_cnt; m++) {
					const int i = f.dup_pts[m](0);
					const int j = f.dup_pts[m](1);
					ifelse(NDIM,3,const int k = f.dup_pts[m](2);)
ifelse(NDIM,2,@
					if(i >= l0 && i <= h0 && j >= l1 && j <= h1) {
						f.dup_value[NDUPFIELDS*m] += f.PsiD(l)(i,j);
					}
@,NDIM,3,@
					if(i >= l0 && i <= h0 && j >= l1 && j <= h1 &&
																	k >= l2 && k <= h2) {
						f.dup_value[NDUPFIELDS*m] += f.PsiD(l)(i,j,k);
					}
@)
				}
			end_for_all_no_sync
			mpReduceAdd(f.dup_value,NDUPFIELDS*f.dup_cnt);
			for(m = 0; m < f.dup_cnt; m++) {
				f.dup_value[NDUPFIELDS*m] *= f.dup_norm[m];
			}
			for_all_1(l,f.PsiD)
				const int l0 = f.fills[l].lower(0);
				const int l1 = f.fills[l].lower(1);
				ifelse(NDIM,3,const int l2 = f.fills[l].lower(2);)
				const int h0 = f.fills[l].upper(0);
				const int h1 = f.fills[l].upper(1);
				ifelse(NDIM,3,const int h2 = f.fills[l].upper(2);)
				for(int m = 0; m < f.dup_cnt; m++) {
					const int i = f.dup_pts[m](0);
					const int j = f.dup_pts[m](1);
					ifelse(NDIM,3,const int k = f.dup_pts[m](2);)
ifelse(NDIM,2,@
					if(i >= l0 && i <= h0 && j >= l1 && j <= h1) {
						f.PsiD(l)(i,j) = f.dup_value[NDUPFIELDS*m];
					}
@,NDIM,3,@
//					if(i >= l0 && i <= h0 && j >= l1 && j <= h1 &&
//																	k >= l2 && k <= h2) {
//						f.PsiD(l)(i,j,k) = f.dup_value[NDUPFIELDS*m];
//	Make sure all phi-periodic duplicate points are filled
					if(j >= l1 && j <= h1 && k >= l2 && k <= h2) {
						if(i >= l0 && i <= h0) {
							f.PsiD(l)(i,j,k) = f.dup_value[NDUPFIELDS*m];
//cout << "Dup Set ^: "<< i << ", " << j << ", " << k << " <- " <<
//												f.dup_value[NDUPFIELDS*m] << endl;
						}
						if(i+N >= l0 && i+N <= h0) {
							f.PsiD(l)(i+N,j,k) = f.dup_value[NDUPFIELDS*m];
//cout << "Dup Set U: "<< i+N << ", " << j << ", " << k << " <- " <<
//												f.dup_value[NDUPFIELDS*m] << endl;
						}
						if(i-N >= l0 && i-N <= h0) {
							f.PsiD(l)(i-N,j,k) = f.dup_value[NDUPFIELDS*m];
//cout << "Dup Set D: "<< i-N << ", " << j << ", " << k << " <- " <<
//												f.dup_value[NDUPFIELDS*m] << endl;
						}
					}
//	Done filling all phi-periodic duplicate points
@)
				}
			end_for_all
		}
		f.sync_fields();
//
		Resnorms = ID_Smooth(f,N_SMOOTHS);
		if(pr && mpMyID() == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << setw(2) << lev << " D| "
										<< setw(10) << Resnorms.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
	}
timer2.exit_section();
}

