#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <stdlib.h>
#include "lparx.h"

// LPARX declarations
//declare_GridX(double)
#include "XArray1GridXdouble.h"

void printX(XArray1(GridX(double)) & G)
{
	const long flagsave = cout.setf(ios::scientific|ios::right);
	const int precsave = cout.precision(18);
   const int Id = mpMyID();
	const int dsize = sizeof(double);
	double * buffer;
	int maxsize = 0;
	for_1(i,G)
		int ts = G(i).region().size();
		if(ts > maxsize) maxsize = ts;
	end_for
	if(Id == 0) {
		buffer = new double[maxsize];
		for_1(i,G)
			int id_G = G(i).owner();
			RegionX G_rgn = G(i).region();
			if(id_G == 0) {
				cout << "Region : " << G_rgn << endl;
ifelse(NDIM,2,@
				for_2(j,k,G_rgn)
					cout << setw(5) << j << " : " << setw(5) << k << " : " 
							<< setw(25) << G(i)(j,k) << endl;
				end_for
@,NDIM,3,@
				for_3(j,k,l,G_rgn)
					cout << setw(5) << j << " : " << setw(5) << k << " : " <<
							setw(5) << l << " : " << setw(25) << G(i)(j,k,l) << endl;
				end_for
@)
			} else {
				int ds = dsize*maxsize;
				mpRecv(id_G,buffer,ds);
				ds = mpLastBytes();
				int ds_chk = dsize*G_rgn.size();
				if(ds == ds_chk) {
					double * ind = buffer; 
					cout << "Region : " << G_rgn << endl;
ifelse(NDIM,2,@
					for_2(j,k,G_rgn)
						cout << setw(5) << j << " : " << setw(5) << k << " : "
								<< setw(25) << *(ind++) << endl;
					end_for
@,NDIM,3,@
					for_3(j,k,l,G_rgn)
						cout << setw(5) << j << " : " << setw(5) << k << " : " <<
								setw(5) << l << " : " << setw(25) << *(ind++) << endl;
					end_for
@)
				} else {
					cout << "Incorrect # of bytes received from " << id_G
							<< ".  Sent " << ds_chk << " received " << ds << endl;
				}
			}
		end_for
	} else {
		for_1(i,G)
			if(G(i).owner() == Id) {
				int ds = dsize*G(i).region().size();
				mpSend(Id,G(i).data(),ds,0);
			}
		end_for
	}
	cout.flags(flagsave);
	cout.precision(precsave);
}
